//  Copyright © 2012 Stephen Smally
//      This program is free software; you can redistribute it and/or modify
//      it under the terms of the GNU General Public License as published by
//      the Free Software Foundation; either version 2 of the License, or
//      (at your option) any later version.
//      
//      This program is distributed in the hope that it will be useful,
//      but WITHOUT ANY WARRANTY; without even the implied warranty of
//      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//      GNU General Public License for more details.
//      
//      You should have received a copy of the GNU General Public License
//      along with this program; if not, write to the Free Software
//      Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
//      MA 02110-1301, USA.
//      

using Gtk;
using Lsc.Backend;

namespace Lsc.Widgets {
    public class InfoMessage : InfoBar {
        // Signals
        public signal void choosed (ResponseId id, LscApp app);
        
        // Widgets
        public Label text;
        public Button info_button;
        public Button action_button;
        private LscApp current_app;
        
        public void update (LscApp app) {
			current_app = app;
            no_show_all = false;
            show_all();
            text.set_label("Selected package <b>%s</b>".printf (app.id));
        }
        
        public void get_response (InfoBar bar, int id) {
			choosed ((ResponseId) id, current_app);
		}
        
        public InfoMessage () {
            message_type = MessageType.INFO;
            ((Box) get_action_area()).orientation = Orientation.HORIZONTAL;
            Box main = get_content_area() as Box;
            main.orientation = Orientation.HORIZONTAL;
            main.spacing = 2;
            orientation = Orientation.HORIZONTAL;
            
            text = new Label("");
            text.use_markup = true;
            text.ellipsize = Pango.EllipsizeMode.END;
            
            add_button(Stock.INFO, ResponseId.INFO);
            add_button("Install", ResponseId.INSTALL);
            
            focus_out_event.connect(() => {
                set_visible(false);
                return true;
            });
            
            main.pack_start(text, false, false, 0);
            no_show_all = true;
            
            response.connect (get_response);
        }
    }
}
